#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct ResolutionIntervalTooSmallForRange {
    #[builder(
        custom(
            type = super::super::super::super::super::objects::scout::run::api::Duration,
            convert = Box::new
        )
    )]
    #[serde(rename = "requestedResolution")]
    requested_resolution: Box<
        super::super::super::super::super::objects::scout::run::api::Duration,
    >,
    #[builder(
        custom(
            type = super::super::super::super::super::objects::api::Timestamp,
            convert = Box::new
        )
    )]
    #[serde(rename = "start")]
    start: Box<super::super::super::super::super::objects::api::Timestamp>,
    #[builder(
        custom(
            type = super::super::super::super::super::objects::api::Timestamp,
            convert = Box::new
        )
    )]
    #[serde(rename = "end")]
    end: Box<super::super::super::super::super::objects::api::Timestamp>,
}
impl ResolutionIntervalTooSmallForRange {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        requested_resolution: super::super::super::super::super::objects::scout::run::api::Duration,
        start: super::super::super::super::super::objects::api::Timestamp,
        end: super::super::super::super::super::objects::api::Timestamp,
    ) -> Self {
        Self::builder()
            .requested_resolution(requested_resolution)
            .start(start)
            .end(end)
            .build()
    }
    #[inline]
    pub fn requested_resolution(
        &self,
    ) -> &super::super::super::super::super::objects::scout::run::api::Duration {
        &*self.requested_resolution
    }
    #[inline]
    pub fn start(&self) -> &super::super::super::super::super::objects::api::Timestamp {
        &*self.start
    }
    #[inline]
    pub fn end(&self) -> &super::super::super::super::super::objects::api::Timestamp {
        &*self.end
    }
}
impl conjure_error::ErrorType for ResolutionIntervalTooSmallForRange {
    #[inline]
    fn code() -> conjure_error::ErrorCode {
        conjure_error::ErrorCode::InvalidArgument
    }
    #[inline]
    fn name() -> &'static str {
        "Compute:ResolutionIntervalTooSmallForRange"
    }
    #[inline]
    fn safe_args() -> &'static [&'static str] {
        &["end", "requestedResolution", "start"]
    }
}
